// VRoadHeightsSpdFileDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "T3ED.h"
#include "T3EDDoc.h"
#include <math.h> 
#include "GridListCtrl.h"
#include "InPlaceEdit.h"
#include "VRoadHeightsSpdFileDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CVRoadHeightsSpdFileDlg 


CVRoadHeightsSpdFileDlg::CVRoadHeightsSpdFileDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVRoadHeightsSpdFileDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVRoadHeightsSpdFileDlg)
	m_Chk_Heights = FALSE;
	m_Chk_SpdFa = FALSE;
	m_Chk_SpdRa = FALSE;
	m_Chk_VRoad = FALSE;
	m_Chk_PVR = FALSE;
	m_Label_Txt = _T("");
	m_Chk_VRoad_z = FALSE;
	//}}AFX_DATA_INIT
	m_pImageList = 0;
	m_pListEdit = 0;
}


void CVRoadHeightsSpdFileDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVRoadHeightsSpdFileDlg)
	DDX_Control(pDX, IDC_LIST, m_GridListCtrl);
	DDX_Check(pDX, IDC_CHECK_HEIGHTS, m_Chk_Heights);
	DDX_Check(pDX, IDC_CHECK_SPDFA, m_Chk_SpdFa);
	DDX_Check(pDX, IDC_CHECK_SPDRA, m_Chk_SpdRa);
	DDX_Check(pDX, IDC_CHECK_VROAD, m_Chk_VRoad);
	DDX_Check(pDX, IDC_CH_PVR, m_Chk_PVR);
	DDX_Text(pDX, IDC_LABEL_TXT, m_Label_Txt);
	DDX_Check(pDX, IDC_CHECK_VRZ, m_Chk_VRoad_z);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CVRoadHeightsSpdFileDlg, CDialog)
	//{{AFX_MSG_MAP(CVRoadHeightsSpdFileDlg)
	ON_NOTIFY(LVN_BEGINLABELEDIT, IDC_LIST, OnBeginlabeleditList)
	ON_NOTIFY(LVN_ENDLABELEDIT, IDC_LIST, OnEndlabeleditList)
	ON_BN_CLICKED(IDC_CHECK_HEIGHTS, OnCheckHeights)
	ON_BN_CLICKED(IDC_CHECK_SPDFA, OnCheckSpdfa)
	ON_BN_CLICKED(IDC_CHECK_SPDRA, OnCheckSpdra)
	ON_BN_CLICKED(IDC_CHECK_VROAD, OnCheckVroad)
	ON_BN_CLICKED(IDC_BT_SWITCH, OnBtSwitchFwBw)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CVRoadHeightsSpdFileDlg 

BOOL CVRoadHeightsSpdFileDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	int i,iActualItem;
	float fw;
	TCHAR buffer[30];

	VERIFY(font.CreateFont(
       16,                        // nHeight
       0,                         // nWidth
       0,                         // nEscapement
       0,                         // nOrientation
       FW_NORMAL,                 // nWeight
       FALSE,					  // bItalic
       FALSE,                     // bUnderline
       0,                         // cStrikeOut
       ANSI_CHARSET,              // nCharSet
       OUT_DEFAULT_PRECIS,        // nOutPrecision
       CLIP_DEFAULT_PRECIS,       // nClipPrecision
       DEFAULT_QUALITY,           // nQuality
       DEFAULT_PITCH | FF_SWISS,  // nPitchAndFamily
       _T("Arial"))
    );  
	
	GetDlgItem(IDC_LIST)->SetFont(&font);

	m_GridListCtrl.SetExtendedStyle(LVS_EX_GRIDLINES);
	m_GridListCtrl.PrepareControl(0);

	LV_ITEM			lvitem;
	LV_COLUMN		lvcolumn;
	CRect rect;
	m_GridListCtrl.GetWindowRect( &rect );


	// Insert columns using the order field
	lvcolumn.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH | LVCF_ORDER;
	lvcolumn.fmt = LVCFMT_LEFT;
	lvcolumn.pszText = "Nr.";
	lvcolumn.iSubItem = 0;
	lvcolumn.iOrder = 0;
	lvcolumn.cx = 40;  
	m_GridListCtrl.InsertColumn(0, &lvcolumn);  

	lvcolumn.pszText = "VRoad X";
	lvcolumn.iSubItem = 1;
	lvcolumn.iOrder = 1;
	lvcolumn.cx = 100;  
	m_GridListCtrl.InsertColumn(1, &lvcolumn);  

	lvcolumn.pszText = "VRoad Y";
	lvcolumn.iSubItem = 2;
	lvcolumn.iOrder = 2;
	lvcolumn.cx = 100;  
	m_GridListCtrl.InsertColumn(2, &lvcolumn);  

	lvcolumn.pszText = "VRoad Z";
	lvcolumn.iSubItem = 3;
	lvcolumn.iOrder = 3;
	lvcolumn.cx = 100;  
	m_GridListCtrl.InsertColumn(3, &lvcolumn);  

	if (bHSMode)
		lvcolumn.pszText = "VR Left"; //VRoad Left
	else
		lvcolumn.pszText = "not used"; //not available in NFS3 
	lvcolumn.cx = 75;  
	lvcolumn.iSubItem = 4;
	lvcolumn.iOrder = 4;
	m_GridListCtrl.InsertColumn(4, &lvcolumn);

	if (bHSMode)
		lvcolumn.pszText = "VR Right"; //VRoad Right
	else
		lvcolumn.pszText = "not used"; //not available in NFS3 
	lvcolumn.cx = 75;  
	lvcolumn.iSubItem = 5;
	lvcolumn.iOrder = 5;
	m_GridListCtrl.InsertColumn(5, &lvcolumn);

	if (bHSMode)
		lvcolumn.pszText = "L-Lane Polys"; //Lane Polys  Left
	else
		lvcolumn.pszText = "not used"; //not available in NFS3 
	lvcolumn.cx = 75;  
	lvcolumn.iSubItem = 6;
	lvcolumn.iOrder = 6;
	m_GridListCtrl.InsertColumn(6, &lvcolumn);

	if (bHSMode)
		lvcolumn.pszText = "R-Lane Polys"; //Lane Polys  Right
	else
		lvcolumn.pszText = "not used"; //not available in NFS3 
	lvcolumn.cx = 75;  
	lvcolumn.iSubItem = 7;
	lvcolumn.iOrder = 7;
	m_GridListCtrl.InsertColumn(7, &lvcolumn);


	if (bHSMode)
		lvcolumn.pszText = "Width L-Polys"; //Width Left Polys
	else
		lvcolumn.pszText = "not used"; //not available in NFS3 
	lvcolumn.cx = 75;  
	lvcolumn.iSubItem = 8;
	lvcolumn.iOrder = 8;
	m_GridListCtrl.InsertColumn(8, &lvcolumn);

	if (bHSMode)
		lvcolumn.pszText = "Width R-Polys"; //Width Right Polys
	else
		lvcolumn.pszText = "not used"; //not available in NFS3 
	lvcolumn.cx = 75;  
	lvcolumn.iSubItem = 9;
	lvcolumn.iOrder = 9;
	m_GridListCtrl.InsertColumn(9, &lvcolumn);


	lvcolumn.pszText = "Heights.sim";
	lvcolumn.iSubItem = 10;
	lvcolumn.iOrder = 10;
	lvcolumn.cx = 100;  
	m_GridListCtrl.InsertColumn(10, &lvcolumn);

	lvcolumn.pszText = "spdFA Speed";
	lvcolumn.iSubItem = 11;
	lvcolumn.iOrder = 11;
	lvcolumn.cx = 100;  
	m_GridListCtrl.InsertColumn(11, &lvcolumn);

	lvcolumn.pszText = "spdFA AI lane selection";
	lvcolumn.iSubItem = 12;
	lvcolumn.iOrder = 12;
	lvcolumn.cx = 100;  
	m_GridListCtrl.InsertColumn(12, &lvcolumn);

	if (bHSMode)
		lvcolumn.pszText = "spdFA float"; //for HS Speedfile
	else
		lvcolumn.pszText = "not used"; //not available in NFS3 speedfile
	lvcolumn.cx = 100;
	lvcolumn.iSubItem = 13;
	lvcolumn.iOrder = 13;
	m_GridListCtrl.InsertColumn(13, &lvcolumn);

	lvcolumn.pszText = "spdRA Speed";
	lvcolumn.iSubItem = 14;
	lvcolumn.iOrder = 14;
	lvcolumn.cx = 100;  
	m_GridListCtrl.InsertColumn(14, &lvcolumn);

	lvcolumn.pszText = "spdRA AI lane selection";
	lvcolumn.iSubItem = 15;
	lvcolumn.iOrder = 15;
	lvcolumn.cx = 100;  
	m_GridListCtrl.InsertColumn(15, &lvcolumn);

	if (bHSMode)
		lvcolumn.pszText = "spdRA float"; //for HS Speedfile
	else
		lvcolumn.pszText = "not used"; //not available in NFS3 speedfile
	lvcolumn.cx = 100;  
	lvcolumn.iSubItem = 16;
	lvcolumn.iOrder = 16;
	m_GridListCtrl.InsertColumn(16, &lvcolumn);



	lvitem.mask=LVIF_TEXT;
	for (i=0;i<m_nPositions;i++)
	{
		lvitem.mask = LVIF_TEXT; //Prepare first colum
		lvitem.iItem=i;
		lvitem.iSubItem=0;
		sprintf(buffer, "%d.", i);
		lvitem.pszText = buffer;
		iActualItem=m_GridListCtrl.InsertItem(&lvitem); //Finally add the column

		lvitem.mask = LVIF_TEXT; //Prepare second colum, add vroad x values
		lvitem.iItem=iActualItem;
		lvitem.iSubItem=1;
		sprintf(buffer, "%f", (float)m_colvrdata[i].refPt.x/65536);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT; //Prepare 3rd colum, add vroad y values
		lvitem.iItem=iActualItem;
		lvitem.iSubItem=2;
		sprintf(buffer, "%f", (float)m_colvrdata[i].refPt.y/65536);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT; //Prepare 4th colum, add vroad z values
		lvitem.iItem=iActualItem;
		lvitem.iSubItem=3;
		sprintf(buffer, "%f", (float)m_colvrdata[i].refPt.z/65536);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);


		lvitem.mask = LVIF_TEXT; //Prepare 5th colum, add VRoad Left Edge
		lvitem.iItem=iActualItem;
		lvitem.iSubItem=4;
		sprintf(buffer, "%d", (int) m_colvrdata[i].leftWall/10000);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT; //Prepare 6th colum, add VRoad Right Edge
		lvitem.iItem=iActualItem;
		lvitem.iSubItem=5;
		sprintf(buffer, "%d", (int) m_colvrdata[i].rightWall/10000);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT; //Prepare 7th colum, add Left lane polys
		lvitem.iItem=iActualItem;
		lvitem.iSubItem=6;
		sprintf(buffer, "%d", (long) hs_extra[i*7 + 3]);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT; //Prepare 8th colum, add Right lane polys
		lvitem.iItem=iActualItem;
		lvitem.iSubItem=7;
		sprintf(buffer, "%d", (long) hs_extra[i*7 + 4]);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT; //Prepare 9th colum, add Width Left lane polys
		lvitem.iItem=iActualItem;
		lvitem.iSubItem=8;
		memcpy(&fw, &hs_extra[i*7 + 0], sizeof(float));
		sprintf(buffer, "%d", (int) fw);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT; //Prepare 10th colum, add Width Right lane polys
		lvitem.iItem=iActualItem;
		lvitem.iSubItem=9;
		memcpy(&fw, &hs_extra[i*7 + 1], sizeof(float));
		sprintf(buffer, "%d", (int) fw);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT; //Prepare 11th colum, add heights.sim values
		lvitem.iItem=iActualItem;
		lvitem.iSubItem=10;
		sprintf(buffer, "%f", (float)m_heightsdata[i].heights);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT; //Prepare 12th colum, add spdFA.bin speed values
		lvitem.iItem=iActualItem;
		lvitem.iSubItem=11;
		sprintf(buffer, "%d", (int)spdFAdata[i].Speedvalue);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT; //Prepare 13th colum, add spdFA.bin best prejection values
		lvitem.iItem=iActualItem;
		lvitem.iSubItem=12;
		sprintf(buffer, "%d", (int)spdFAdata[i].Bestprejection);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT; //Prepare 14th colum, add spdFA.bin float values
		lvitem.iItem=iActualItem;
		lvitem.iSubItem=13;
		sprintf(buffer, "%f", (float)spdFAdata[i].turn);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT; //Prepare 15th colum, add spdRA.bin speed values
		lvitem.iItem=iActualItem;
		lvitem.iSubItem=14;
		sprintf(buffer, "%d", (int)spdRAdata[i].Speedvalue);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT; //Prepare 16th colum, add spdRA.bin best prejection values
		lvitem.iItem=iActualItem;
		lvitem.iSubItem=15;
		sprintf(buffer, "%d", (int)spdRAdata[i].Bestprejection);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT; //Prepare 17th colum, add spdRA.bin float values
		lvitem.iItem=iActualItem;
		lvitem.iSubItem=16;
		sprintf(buffer, "%f", (float)spdRAdata[i].turn);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);

	}
	
	OnCheckVroad();
	OnCheckHeights();
	OnCheckSpdfa();
	OnCheckSpdra();
	if (!bHSMode) 
		HideFloat();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}


void CVRoadHeightsSpdFileDlg::OnBeginlabeleditList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_DISPINFO* pDispInfo = (LV_DISPINFO*)pNMHDR;

	CString str = pDispInfo->item.pszText;
	int item = pDispInfo->item.iItem;
	int subitem = pDispInfo->item.iSubItem;
	// Construct and create the custom multiline edit control.
	// We could just as well have used a combobox, checkbox, 
	// rich text control, etc.
	m_pListEdit = new CInPlaceEdit( item, subitem, str );
	// Start with a small rectangle.  We'll change it later.
	CRect  rect( 0,0,1,1 );
	DWORD dwStyle = ES_LEFT;
	dwStyle |= WS_BORDER|WS_CHILD|WS_VISIBLE|ES_MULTILINE|ES_AUTOVSCROLL;
	m_pListEdit->Create( dwStyle, rect, &m_GridListCtrl, 103 );
	// Have the Grid position and size the custom edit control
	m_GridListCtrl.PositionControl( m_pListEdit, item, subitem );
	// Have the edit box size itself to its content.
	m_pListEdit->CalculateSize();
	// Return TRUE so that the list control will hnadle NOT edit label itself. 
	*pResult = 1;
}

void CVRoadHeightsSpdFileDlg::OnEndlabeleditList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_DISPINFO* pDispInfo = (LV_DISPINFO*)pNMHDR;
	// TODO: Add your control notification handler code here
	int item = pDispInfo->item.iItem;
	int subitem = pDispInfo->item.iSubItem;
	// This is coming from the grid list control notification.
	if( m_pListEdit )
		{
		CString str;
		if( pDispInfo->item.pszText )
			m_GridListCtrl.SetItemText( item, subitem, pDispInfo->item.pszText );
		delete m_pListEdit;
		m_pListEdit = 0;
		}
	*pResult = 0;
}

void CVRoadHeightsSpdFileDlg::OnOK() 
{
	int i,iw;
	//CString Str;
	float fw;

	for (i=0;i<m_nPositions;i++) //Read the changed values and write them back
	{
		//Read Values from GridList
		if (sscanf(m_GridListCtrl.GetItemText(i,1), "%f",&fw)==1)
			m_colvrdata[i].refPt.x=(int) Runden(65536 * fw); //VRoad.x is valid
		if (sscanf(m_GridListCtrl.GetItemText(i,2), "%f",&fw)==1)
			m_colvrdata[i].refPt.y=(int) Runden(65536 * fw); //VRoad.Y is valid
		if (sscanf(m_GridListCtrl.GetItemText(i,3), "%f",&fw)==1)
			m_colvrdata[i].refPt.z=(int) Runden(65536 * fw); //VRoad.Z is valid

		if (sscanf(m_GridListCtrl.GetItemText(i,4), "%f",&fw)==1)
			m_colvrdata[i].leftWall=(long) fw * 10000; //VRoad Left Edge
		if (sscanf(m_GridListCtrl.GetItemText(i,5), "%f",&fw)==1)
			m_colvrdata[i].rightWall=(long) fw * 10000; //VRoad Right Edge

		if (sscanf(m_GridListCtrl.GetItemText(i,6), "%d",&iw)==1)
			hs_extra[i*7 + 3]=(long) iw; //Left lane polys is valid
		if (sscanf(m_GridListCtrl.GetItemText(i,7), "%d",&iw)==1)
			hs_extra[i*7 + 4]=(long) iw; //Right lane polys is valid


		if (sscanf(m_GridListCtrl.GetItemText(i,8), "%d",&iw)==1) //Width Left lane polys is valid
		{
			fw = (float) iw;
			memcpy(&hs_extra[i*7 + 0], &fw, sizeof(float));
		}


		if (sscanf(m_GridListCtrl.GetItemText(i,9), "%d",&iw)==1) //Width Right lane polys is valid
		{
			fw = (float) iw;
			memcpy(&hs_extra[i*7 + 1], &fw, sizeof(float));
		}


		if (sscanf(m_GridListCtrl.GetItemText(i,10), "%f",&fw)==1)
			m_heightsdata[i].heights=fw; //heights is valid
		if (sscanf(m_GridListCtrl.GetItemText(i,11), "%d",&iw)==1)
			spdFAdata[i].Speedvalue=iw; //Speedvalue is valid
		if (sscanf(m_GridListCtrl.GetItemText(i,12), "%d",&iw)==1)
			spdFAdata[i].Bestprejection=iw; //Speedvalue is valid
		if (sscanf(m_GridListCtrl.GetItemText(i,13), "%f",&fw)==1)
			spdFAdata[i].turn=fw; //heights is valid
		if (sscanf(m_GridListCtrl.GetItemText(i,14), "%d",&iw)==1)
			spdRAdata[i].Speedvalue=iw; //Speedvalue is valid
		if (sscanf(m_GridListCtrl.GetItemText(i,15), "%d",&iw)==1)
			spdRAdata[i].Bestprejection=iw; //Speedvalue is valid
		if (sscanf(m_GridListCtrl.GetItemText(i,16), "%f",&fw)==1)
			spdRAdata[i].turn=fw; //heights is valid

	}
	
	CDialog::OnOK();
}

double CVRoadHeightsSpdFileDlg::Runden(double x)
{
	return (x >= 0) ? floor(x+0.5) : ceil(x-0.5);
}

void CVRoadHeightsSpdFileDlg::OnCheckHeights() 
{
	UpdateData(TRUE);
	if (m_Chk_Heights)
		m_GridListCtrl.SetColumnWidth(10,100);
	else
		m_GridListCtrl.SetColumnWidth(10,0);
	UpdateData(FALSE);	
}

void CVRoadHeightsSpdFileDlg::OnCheckSpdfa() 
{
	UpdateData(TRUE);
	if (m_Chk_SpdFa)
	{
		m_GridListCtrl.SetColumnWidth(11,100);
		m_GridListCtrl.SetColumnWidth(12,100);
		if (bHSMode) m_GridListCtrl.SetColumnWidth(13,100);
	}
	else
	{
		m_GridListCtrl.SetColumnWidth(11,0);
		m_GridListCtrl.SetColumnWidth(12,0);
		m_GridListCtrl.SetColumnWidth(13,0);
	}
	UpdateData(FALSE);	
}

void CVRoadHeightsSpdFileDlg::OnCheckSpdra() 
{
	UpdateData(TRUE);
	if (m_Chk_SpdRa)
	{
		m_GridListCtrl.SetColumnWidth(14,100);
		m_GridListCtrl.SetColumnWidth(15,100);
		if (bHSMode) m_GridListCtrl.SetColumnWidth(16,100);
	}
	else
	{
		m_GridListCtrl.SetColumnWidth(14,0);
		m_GridListCtrl.SetColumnWidth(15,0);
		m_GridListCtrl.SetColumnWidth(16,0);
	}
	UpdateData(FALSE);	
}

void CVRoadHeightsSpdFileDlg::OnCheckVroad() 
{
	int i;
	UpdateData(TRUE);
	if (m_Chk_VRoad)
	{
		m_GridListCtrl.SetColumnWidth(1,100);
		m_GridListCtrl.SetColumnWidth(2,100);
		m_GridListCtrl.SetColumnWidth(3,100);
		m_GridListCtrl.SetColumnWidth(4,75);
		m_GridListCtrl.SetColumnWidth(5,75);
		if (bHSMode)
		{
			m_GridListCtrl.SetColumnWidth(6,75);
			m_GridListCtrl.SetColumnWidth(7,75);

			m_GridListCtrl.SetColumnWidth(8,75);
			m_GridListCtrl.SetColumnWidth(9,75);
		}

	}
	else
	{
		for (i=1;i<10;i++)
			m_GridListCtrl.SetColumnWidth(i,0);
	}
	UpdateData(FALSE);
}

void CVRoadHeightsSpdFileDlg::HideFloat()
{
	UpdateData(TRUE);
	m_GridListCtrl.SetColumnWidth(13,0);
	m_GridListCtrl.SetColumnWidth(16,0);
	UpdateData(FALSE);
}

void CVRoadHeightsSpdFileDlg::OnBtSwitchFwBw() 
{
	int i;
	struct COLVROAD *backup_colvrdata;
	struct HEIGHTSSIM *backup_heightsdata;
	struct SPDFILE *b_spdFAdata;
	struct SPDFILE *b_spdRAdata;

	backup_colvrdata=(struct COLVROAD *)malloc(m_nPositions*sizeof(struct COLVROAD));
	backup_heightsdata=(struct HEIGHTSSIM *)malloc(m_nPositions*sizeof(struct HEIGHTSSIM));
	b_spdFAdata=(struct SPDFILE *)malloc(m_nPositions*sizeof(struct SPDFILE));
	b_spdRAdata=(struct SPDFILE *)malloc(m_nPositions*sizeof(struct SPDFILE));


	for (i=0;i<m_nPositions;i++) {  //Backup
		backup_colvrdata[i]=m_colvrdata[i];
		backup_heightsdata[i]=m_heightsdata[i];
		b_spdFAdata[i]=spdFAdata[i];
		b_spdRAdata[i]=spdRAdata[i];
	}


	for (i=0;i<m_nPositions;i++) { //switch order of data
		m_colvrdata[i]=backup_colvrdata[m_nPositions -i -1];
		m_heightsdata[i]=backup_heightsdata[m_nPositions -i -1];
		spdFAdata[i]=b_spdRAdata[m_nPositions -i -1];   //Direction has changed!
		spdRAdata[i]=b_spdFAdata[m_nPositions -i -1];
	}


	dofree(backup_colvrdata);
	dofree(backup_heightsdata);
	dofree(b_spdFAdata);
	dofree(b_spdRAdata);
	UpdateView();

}

void CVRoadHeightsSpdFileDlg::UpdateView()
{
	int i;
	TCHAR buffer[30];

	LV_ITEM			lvitem;
	//LV_COLUMN		lvcolumn;
	CRect rect;
	m_GridListCtrl.GetWindowRect( &rect );


	lvitem.mask=LVIF_TEXT;
	for (i=0;i<m_nPositions;i++)
	{
		lvitem.mask = LVIF_TEXT; //update vroad x values
		lvitem.iItem=i;
		lvitem.iSubItem=1;
		sprintf(buffer, "%f", (float)m_colvrdata[i].refPt.x/65536);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT; //update vroad y values
		lvitem.iItem=i;
		lvitem.iSubItem=2;
		sprintf(buffer, "%f", (float)m_colvrdata[i].refPt.y/65536);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT; //update vroad z values
		lvitem.iItem=i;
		lvitem.iSubItem=3;
		sprintf(buffer, "%f", (float)m_colvrdata[i].refPt.z/65536);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);


		lvitem.mask = LVIF_TEXT; //update VRoad Left Edge
		lvitem.iItem=i;
		lvitem.iSubItem=4;
		sprintf(buffer, "%d", (int) m_colvrdata[i].leftWall/10000);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT; //update VRoad Right Edge
		lvitem.iItem=i;
		lvitem.iSubItem=5;
		sprintf(buffer, "%d", (int) m_colvrdata[i].rightWall/10000);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT; //update Left lane polys
		lvitem.iItem=i;
		lvitem.iSubItem=6;
		sprintf(buffer, "%d", (long) hs_extra[i*7 + 3]);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT; //update Right lane polys
		lvitem.iItem=i;
		lvitem.iSubItem=7;
		sprintf(buffer, "%d", (long) hs_extra[i*7 + 4]);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);




		lvitem.mask = LVIF_TEXT; //update heights.sim values
		lvitem.iItem=i;
		lvitem.iSubItem=8;
		sprintf(buffer, "%f", (float)m_heightsdata[i].heights);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT; //update spdFA.bin speed values
		lvitem.iItem=i;
		lvitem.iSubItem=9;
		sprintf(buffer, "%d", (int)spdFAdata[i].Speedvalue);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT; //update spdFA.bin best prejection values
		lvitem.iItem=i;
		lvitem.iSubItem=10;
		sprintf(buffer, "%d", (int)spdFAdata[i].Bestprejection);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT; //update spdFA.bin turn values
		lvitem.iItem=i;
		lvitem.iSubItem=11;
		sprintf(buffer, "%f", (float)spdFAdata[i].turn);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT; //update spdRA.bin speed values
		lvitem.iItem=i;
		lvitem.iSubItem=12;
		sprintf(buffer, "%d", (int)spdRAdata[i].Speedvalue);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT; //update spdRA.bin best prejection values
		lvitem.iItem=i;
		lvitem.iSubItem=13;
		sprintf(buffer, "%d", (int)spdRAdata[i].Bestprejection);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT; //update spdRA.bin turn values
		lvitem.iItem=i;
		lvitem.iSubItem=14;
		sprintf(buffer, "%f", (float)spdRAdata[i].turn);
		lvitem.pszText = buffer;
		m_GridListCtrl.SetItem(&lvitem);

	}

}
