// VirtualRoadAdjust.cpp : implementation file
//

#include "stdafx.h"
#include "T3ED.h"
#include "VirtualRoadAdjust.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVirtualRoadAdjust dialog


CVirtualRoadAdjust::CVirtualRoadAdjust(CWnd* pParent /*=NULL*/)
	: CDialog(CVirtualRoadAdjust::IDD, pParent)
{
	

	//{{AFX_DATA_INIT(CVirtualRoadAdjust)
	m_StartBlock = 0;
	m_EndBlock = 0;
	m_AdjustType = -1;
	m_DisableStartEnd = false;
	m_Check_Lane = FALSE;
	m_Check_VR = FALSE;
	m_int_Size_VR_L = 0;
	m_int_Size_VR_R = 0;
	m_int_Size_Lane_L = 0;
	m_int_Size_Lane_R = 0;
	m_bHSMode=FALSE;
	//}}AFX_DATA_INIT
}


void CVirtualRoadAdjust::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CDialog::OnFinalRelease();
}

void CVirtualRoadAdjust::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVirtualRoadAdjust)
	DDX_Text(pDX, IDC_EDIT1, m_StartBlock);
	DDV_MinMaxInt(pDX, m_StartBlock, 0, 300);
	DDX_Text(pDX, IDC_EDIT2, m_EndBlock);
	DDV_MinMaxInt(pDX, m_EndBlock, 0, 300);
	DDX_Radio(pDX, IDC_RADIO1, m_AdjustType);
	DDX_Check(pDX, IDC_CHECK_LANE, m_Check_Lane);
	DDX_Check(pDX, IDC_CHECK_VR, m_Check_VR);
	DDX_Text(pDX, IDC_EDIT_SIZE_VRL, m_int_Size_VR_L);
	DDX_Text(pDX, IDC_EDIT_SIZE_VRR, m_int_Size_VR_R);
	DDX_Text(pDX, IDC_EDIT_SIZE_LANE_L, m_int_Size_Lane_L);
	DDV_MinMaxUInt(pDX, m_int_Size_Lane_L, 0, 10);
	DDX_Text(pDX, IDC_EDIT_SIZE_LANE_R, m_int_Size_Lane_R);
	DDV_MinMaxUInt(pDX, m_int_Size_Lane_R, 0, 10);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CVirtualRoadAdjust, CDialog)
	//{{AFX_MSG_MAP(CVirtualRoadAdjust)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_BN_CLICKED(IDC_RADIO3, OnRadio3)
	ON_BN_CLICKED(IDC_RADIO4, OnRadio4)
	ON_BN_CLICKED(IDC_CHECK_LANE, OnCheckLane)
	ON_BN_CLICKED(IDC_CHECK_VR, OnCheckVr)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CVirtualRoadAdjust message handlers

void CVirtualRoadAdjust::OnSetfocusEditSize() 
{
	UpdateData(true); //Get other changes
	m_AdjustType=3; //Set to Radio 3 
	UpdateData(false); 	//Show Radio3 selected
}

void CVirtualRoadAdjust::OnChangeEditSize() 
{
	// TODO: Wenn dies ein RICHEDIT-Steuerelement ist, sendet das Steuerelement diese

	// Benachrichtigung nicht, bevor Sie nicht die Funktion CDialog::OnInitDialog()

	// berschreiben und CRichEditCrtl().SetEventMask() aufrufen, wobei

	// eine ODER-Operation mit dem Attribut ENM_CHANGE und der Maske erfolgt.

	
	UpdateData(true); //Get other changes

	
}

BOOL CVirtualRoadAdjust::OnInitDialog() 
{
	CDialog::OnInitDialog();

	UpdateView();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void CVirtualRoadAdjust::UpdateView()
{
	CWnd *edit1=GetDlgItem(IDC_EDIT1);
	CWnd *edit2=GetDlgItem(IDC_EDIT2);
	UpdateData(true);

	if (m_DisableStartEnd)
	{
		edit1->EnableWindow(FALSE);
		edit2->EnableWindow(FALSE);
	}
	if (m_AdjustType<3)
	{
		GetDlgItem(IDC_CHECK_VR)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_SIZE_VRL)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_SIZE_VRR)->EnableWindow(FALSE);

		GetDlgItem(IDC_CHECK_LANE)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_SIZE_LANE_L)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_SIZE_LANE_R)->EnableWindow(FALSE);

	}
	else
	{
		GetDlgItem(IDC_CHECK_VR)->EnableWindow(TRUE);

		GetDlgItem(IDC_EDIT_SIZE_VRL)->EnableWindow(m_Check_VR);
		GetDlgItem(IDC_EDIT_SIZE_VRR)->EnableWindow(m_Check_VR);

		if (m_bHSMode)
		{
			GetDlgItem(IDC_CHECK_LANE)->EnableWindow(TRUE);

			GetDlgItem(IDC_EDIT_SIZE_LANE_L)->EnableWindow(m_Check_Lane);
			GetDlgItem(IDC_EDIT_SIZE_LANE_R)->EnableWindow(m_Check_Lane);
		}

	}
	UpdateData(FALSE);
}

void CVirtualRoadAdjust::OnRadio1() 
{
	UpdateView();
}

void CVirtualRoadAdjust::OnRadio2() 
{
	UpdateView();
}

void CVirtualRoadAdjust::OnRadio3() 
{
	UpdateView();
}

void CVirtualRoadAdjust::OnRadio4() 
{
	UpdateView();
}

void CVirtualRoadAdjust::OnOK() 
{
	// TODO: Zustzliche Prfung hier einfgen
	
	CDialog::OnOK();
}

void CVirtualRoadAdjust::OnCheckLane() 
{
	UpdateView();
}

void CVirtualRoadAdjust::OnCheckVr() 
{
	UpdateView();	
}
